//FullscreenRegion class
//original by Daniel van Vugt <daniel.van.vugt@canonical.com>
//backport to 0.9.7 by Chris Xiong <chirs241097@gmail.com>
//EXPERIMENTAL
#ifndef PRIVATE_PAINT_H
#define PRIVATE_PAINT_H
#include "core/rect.h"
#include "core/region.h"
namespace compiz
{
	namespace opengl
	{
		class FullscreenRegion
		{
		public:
			typedef enum
			{
				Normal=0,
				Desktop
			}WinType;
			FullscreenRegion(const CompRect &rect);
			bool isCoveredBy(const CompRegion &region,WinType type=Normal);
		private:
			bool covered;
			CompRegion untouched;
		};
		FullscreenRegion::FullscreenRegion(const CompRect &rect):covered(false),untouched(rect){}
		bool FullscreenRegion::isCoveredBy(const CompRegion &region,WinType type)
		{
			bool res=false;
			if (!covered&&type==Normal&&region==untouched)covered=res=true;
			untouched-=region;
			return res;
		}
	}
}
#endif
