#include "screensaver.h"
#include <cmath>


#define sigmoid(x) (1.0f/(1.0f+exp(-5.5f*2*((x)-0.5))))
#define sigmoidProgress(x) ((sigmoid(x) - sigmoid(0)) / \
							(sigmoid(1) - sigmoid(0)))


void
ScreenEffect::handleEvent (XEvent *event)
{
    ScreenWrapper::handleEvent (event);
}

void
ScreenEffect::cubeGetRotation (float &x, float &v, float &progress)
{
    ScreenWrapper::cubeGetRotation (x, v, progress);
}

bool ScreenEffect::enable()
{
	progress = 0.0;
	return true;
}

void ScreenEffect::preparePaint (int msSinceLastPaint )
{
	if( ss->mState.running )
	{
		if( ss->mState.fadingIn )
		{
			float fadeDuration = ss->optionGetFadeInDuration ()*1000.0;
			progress = sigmoidProgress(((float)ss->mTime)/fadeDuration);
			ss->mTime += msSinceLastPaint;
			if( ss->mTime >= fadeDuration )
			{
				if( ss->optionGetStartAutomatically() )
					XActivateScreenSaver(screen->dpy ());
				ss->mState.fadingIn = FALSE;
				ss->mTime = 0;
			}
		}
		
		else if( ss->mState.fadingOut )
		{
			float fadeDuration = ss->optionGetFadeOutDuration()*1000.0;
			progress = sigmoidProgress( ((float)ss->mTime)/fadeDuration );
			ss->mTime += msSinceLastPaint;
			if( ss->mTime >= fadeDuration )
			{
				clean();
				ss->mEffect->cleanEffect = true;
				ss->mState.running = FALSE;
				ss->cScreen->damageScreen();
			}
		}
		
		else
		{
		    progress = 1.0;
		}
	}
	
	ScreenWrapper::preparePaint ( msSinceLastPaint );
}
