#ifndef FLYINGWINDOWS_H
#define FLYINGWINDOWS_H

#include "screensaver.h"

class ScreenFlyingWindows : public ScreenEffect
{
public:
	ScreenFlyingWindows() : ScreenEffect() {}
	virtual ~ScreenFlyingWindows() {}
	
	virtual void handleEvent (XEvent *event);
	virtual bool enable();
	virtual void disable();
	virtual void preparePaint (int);
	virtual void donePaint ();
	virtual void glPaintTransformedOutput (const GLScreenPaintAttrib &,
					       const GLMatrix		 &,
					       const CompRegion		 &,
					       CompOutput		 *,
					       unsigned int		   );
	virtual bool glPaintOutput (const GLScreenPaintAttrib	 &,
			            const GLMatrix		 &,
			            const CompRegion		 &,
			            CompOutput		 	 *,
			            unsigned int		   );
	virtual void paint (CompOutput::ptrList &,
			    unsigned int	 );
private:
	void initWindow( CompWindow* _w );
	void recalcVertices( CompWindow* _w );
	void addForce( const Point& p1, const Point& p2, const Point& center, Vector& resultante, Vector& couple, float w, bool attract );
};

class WindowFlyingWindows : public WindowEffect
{
	friend class ScreenFlyingWindows;
	
public:
	WindowFlyingWindows( CompWindow* w );
	virtual ~WindowFlyingWindows() {}
	void initWindow();
	virtual bool glPaint (const GLWindowPaintAttrib &,
			      const GLMatrix 	        &,
			      const CompRegion		&,
			      unsigned int		  );
	void recalcVertices();
	
	static WindowFlyingWindows& getInstance( CompWindow* w ) { return (WindowFlyingWindows& )*ScreenSaverWindow::get (w)->mEffect; }
		
private:
	bool isActiveWin();
	
	// isScreenSaverWin()
	bool active;
	
	// used for non-active window like the desktop
	GLushort opacity;
	GLushort opacityFadeOut;
	GLushort opacityOld;
	int steps;
	
	// used for active window
	// translate matrix
	Matrix transformTrans;
	
	// rotation matrix
	Matrix centerTrans, transformRot, centerTransInv;
	
	// precomputed transform matrix
	Matrix transform;
	
	Matrix transformFadeOut;

	// 5 normalized vertices are stored, the four corners and the center
	Point vertex[5];
	
	// normalized speed vectors
	Vector speed;
	Vector speedrot;
};

#endif
