#include "screensaver.h"

void ScreenWrapper::handleEvent( XEvent *event )
{
	screen->handleEvent (event);
}

ScreenWrapper::ScreenWrapper ()
{
	SCREENSAVER_SCREEN(screen);
	this->s = screen;
	this->ss = ss;
}

void ScreenWrapper::cubeGetRotation( float& x, float& v, float &progress )
{
	ss->cubeScreen->cubeGetRotation (x, v, progress);
}

void ScreenWrapper::preparePaint (int msSinceLastPaint )
{
	ss->cScreen->preparePaint (msSinceLastPaint);
}

void ScreenWrapper::donePaint ()
{
	ss->cScreen->donePaint ();
}

void ScreenWrapper::glPaintTransformedOutput (const GLScreenPaintAttrib &attrib,
					      const GLMatrix		 &transform,
					      const CompRegion		 &region,
					      CompOutput		 	*output,
					      unsigned int		mask)
{
	ss->gScreen->glPaintTransformedOutput (attrib, transform, region, output, mask);
}

bool ScreenWrapper::glPaintOutput (const GLScreenPaintAttrib &attrib,
			           const GLMatrix		 &transform,
				   const CompRegion		 &region,
				   CompOutput		 *output,
				   unsigned int		mask)
{
	return ss->gScreen->glPaintOutput (attrib, transform, region, output, mask);
}

void ScreenWrapper::paint (CompOutput::ptrList &outputs,
			   unsigned int	       mask)
{
	ss->cScreen->paint (outputs, mask);
}


WindowWrapper::WindowWrapper( CompWindow* w )
{
	SCREENSAVER_WINDOW(w);
	this->w = w;
	this->sw = sw;
}

bool WindowWrapper::glPaint (const GLWindowPaintAttrib &attrib,
			     const GLMatrix	       &transform,
			     const CompRegion	       &region,
			     unsigned int	       mask)
{
	return sw->gWindow->glPaint (attrib, transform, region, mask);
}
